#! /usr/bin/env python

import sys, os

if len(sys.argv) == 3:
   start_dir = '.'
elif len(sys.argv) == 4:
   start_dir = sys.argv[3]
else:
   sys.exit("Usage: %s src_enc dst_enc [start_dir]" % sys.argv[0])


def _p(plist, dirname, names):
   plist.append((dirname, names))


plist = []
os.path.walk(start_dir, _p, plist)
plist.reverse()


from recode_filenames import _recode

save_dir = os.getcwd()
for dirname, names in plist:
   os.chdir(dirname)
   for filename in names:
      # if not exists - it was renamed already
      if os.path.exists(filename) and \
            os.path.isfile(filename):
         newname = _recode(filename)
         if newname <> filename:
            os.rename(filename, newname)
   os.chdir('..')
   dirname = os.path.basename(dirname)
   newname = _recode(dirname)
   if newname <> dirname:
      os.rename(dirname, newname)
   os.chdir(save_dir)
